
(function () {
    window.ydkConfigHelper = {
        modules: {
        },
        jsApiList: [],
        debug: false,
        register: function (native) {

            var _loop = function _loop(moduleName) {
                var funcList = ydkConfigHelper.modules[moduleName];
                native[moduleName] = {};
            
                var _loop2 = function _loop2(funcName) {
                    var argsList = funcList[funcName];
                    native[moduleName][funcName] = function () {
                        var inArguments = arguments;
                        return new Promise(function (resolve, reject) {
                            var args = {};
                            for (var index in inArguments) {
                                args[argsList[index]] = inArguments[index];
                            }
                            var callback = {};
                            callback.success = function(res) {
                                resolve(res.data);
                            }
                            callback.fail = function(res) {
                                reject(res.data);
                            }
                            callback.cancel = function(res) {
                                reject(res.data);
                            }
                            ydk._invoke(moduleName + '_' + funcName, args, callback)
                        });
                    };
                };
            
                for (var funcName in funcList) {
                    _loop2(funcName);
                    window.ydkConfigHelper.jsApiList.push(moduleName + '_' + funcName)
                }
            };
            
            for (var moduleName in ydkConfigHelper.modules) {
                _loop(moduleName);
            }
            ydk.config(window.ydkConfigHelper)
        }
    };
 
})();